Bug 1412008 - Review Request: docker-client-java - docker client library for java
Summary: Review Request: docker-client-java - docker client library for java
Keywords:
Status: CLOSED DUPLICATE of bug 1473851
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Roland Grunberg
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1411966
TreeView+ depends on / blocked
 
Reported: 2017-01-11 00:33 UTC by Jeff Johnston
Modified: 2017-07-21 21:02 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-07-21 21:02:45 UTC
Type: ---
rgrunber: fedora-review+


Attachments (Terms of Use)

Description Jeff Johnston 2017-01-11 00:33:32 UTC
Spec URL: http://www.vermillionskye.com/docker-client-java.spec
SRPM URL: http://www.vermillionskye.com/docker-client-java-4.0.6-4.fc26.src.rpm

Description: This is a package containing the com.spotify docker-client library
used by java code to access the docker daemon.  This was previously packaged
as docker-client and is being renamed to allow the docker server to use the old
package name.
Fedora Account System Username: jjohnstn

Comment 1 Roland Grunberg 2017-01-11 15:50:13 UTC
I'll take this review.

This is in fact a request to rename docker-client (The Java library providing API + Impl for Docker Daemon calls) to docker-client-java so that the docker package itself may split its own client into a subpackage called docker-client.

In addition to a standard review, I'll also be checking for the proper Provides/Obsoletes : https://fedoraproject.org/wiki/Packaging:Guidelines#Renaming.2FReplacing_Existing_Packages

Comment 2 Roland Grunberg 2017-01-11 17:08:30 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
[!]: Package complies to the Packaging Guidelines
I Don't think we can use SCL macros within the spec file. This is something
that was done a while ago to ease packaging but it's actually against the
guidelines. See :

https://fedoraproject.org/wiki/Packaging:Guidelines#Software_Collection_Macros

For software collections, there should be scripts in place that automatically
insert the macros where needed, for the most part.

[!]: Rpmlint is run on all rpms the build produces.
docker-client-java.src:9: W: mixed-use-of-spaces-and-tabs (spaces: line 4, tab: line 9)


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[-]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[!]: Rpmlint is run on all rpms the build produces.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[-]: Latest version is packaged.
Since this is a package rename request, it should be ok to simply rename the
package and update to a newer version. There is an active bug for updating to
the latest upstream release (Bug 1343785, currently 7.0.0).
Note that upstream releases very often.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.

[x]: Reviewer should test that the package builds in mock.
I've also rebuilt against Fedora rawhide in addition to f24.

[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
[x]: Spec file according to URL is the same as in SRPM.
[x]: Package rename guidelines were followed and correct Provides/Obsoletes are present



Rpmlint
-------
Checking: docker-client-java-4.0.6-4.fc24.noarch.rpm
          docker-client-java-4.0.6-4.fc24.src.rpm
docker-client-java.src:9: W: mixed-use-of-spaces-and-tabs (spaces: line 4, tab: line 9)
2 packages and 0 specfiles checked; 0 errors, 1 warnings.


Requires
--------
docker-client-java (rpmlib, GLIBC filtered):
    glassfish-jaxb-api
    java-headless
    jpackage-utils
    mvn(com.fasterxml.jackson.core:jackson-databind)
    mvn(com.fasterxml.jackson.datatype:jackson-datatype-guava)
    mvn(com.fasterxml.jackson.jaxrs:jackson-jaxrs-json-provider)
    mvn(com.github.jnr:jnr-unixsocket)
    mvn(com.google.guava:guava)
    mvn(commons-lang:commons-lang)
    mvn(org.apache.commons:commons-compress)
    mvn(org.apache.httpcomponents:httpclient)
    mvn(org.bouncycastle:bcpkix-jdk15on)
    mvn(org.glassfish.jersey.connectors:jersey-apache-connector)
    mvn(org.glassfish.jersey.core:jersey-client)
    mvn(org.glassfish.jersey.media:jersey-media-json-jackson)
    mvn(org.slf4j:slf4j-api)
    osgi(org.glassfish.hk2.locator)



Provides
--------
docker-client-java:
    docker-client
    docker-client-java
    mvn(com.spotify:docker-client)
    mvn(com.spotify:docker-client:pom:)
    osgi(com.spotify.docker.client)


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1412008
Buildroot used: fedora-24-x86_64 (built against fedora rawhide also)
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 Roland Grunberg 2017-01-11 17:12:31 UTC
One additional thing worth correcting :

The specfile uses '0%{fedora}' . If %{fedora} is not defined, then this evaluates to 0%{fedora} . To allow the %if to evaluate correctly, the expression should be 0%{?fedora} .

Comment 4 Jeff Johnston 2017-01-11 17:33:18 UTC
(In reply to Roland Grunberg from comment #2)

Spec URL: http://www.vermillionskye.com/docker-client-java.spec
SRPM URL: http://www.vermillionskye.com/docker-client-java-4.0.6-4.fc26.src.rpm

Description: This is a package containing the com.spotify docker-client library
used by java code to access the docker daemon.  This was previously packaged
as docker-client and is being renamed to allow the docker server to use the old
package name.
Fedora Account System Username: jjohnstn

[jjohnstn@localhost docker-client]$ rpmlint docker-client-java-4.0.6-4.fc26.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

[jjohnstn@localhost docker-client]$ rpmlint docker-client-java.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

Comment 5 Roland Grunberg 2017-01-11 18:27:31 UTC
[x]: Package complies to the Packaging Guidelines
[x]: Rpmlint is run on all rpms the build produces.
2 packages and 0 specfiles checked; 0 errors, 0 warnings.

================
*** APPROVED ***
================

Comment 6 Roland Grunberg 2017-07-21 21:02:45 UTC
As much as I'd like the scm-request here, this review has become stale, so I'll do a re-review of this (re-review) at Bug 1473851 (which Jeff has re-opened). I'll mark this bug as a duplicate.

*** This bug has been marked as a duplicate of bug 1473851 ***


Note You need to log in before you can comment on or make changes to this bug.